<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.plot.plotter &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.plot.plotter</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.plot.plotter</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module that defines a ``Plotter``, used to different columns of a common</span>
<span class="sd">set of samples.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">List</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>

<span class="kn">from</span> <span class="nn">..handle.handle_list</span> <span class="kn">import</span> <span class="n">_type_to_list</span>
<span class="kn">from</span> <span class="nn">..handle.handle_dict</span> <span class="kn">import</span> <span class="n">_none_to_dict</span>
<span class="kn">from</span> <span class="nn">.plot_hist</span> <span class="kn">import</span> <span class="n">plot_hist</span>
<span class="kn">from</span> <span class="nn">.tools</span> <span class="kn">import</span> <span class="n">get_multi_fig_ax</span>


<div class="viewcode-block" id="Plotter"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter">[docs]</a><span class="k">class</span> <span class="nc">Plotter</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Object to plot many histograms</span>

<span class="sd">    Attributes:</span>
<span class="sd">        dict_samples: associates a sample id with a sample</span>
<span class="sd">        dict_sample_params: associates a parameter (e.g., `color`, etc.) with</span>
<span class="sd">            another dictionnary, that associates a sample id with the value</span>
<span class="sd">            of the parameter</span>
<span class="sd">        dict_column_ranges: associates a column with its range</span>
<span class="sd">        dict_default_params: associates a parameter used in the plots with</span>
<span class="sd">            its default value (e.g., `bins`, `density`)</span>
<span class="sd">        dict_default_sample_params: associates a parameter name with its</span>
<span class="sd">            default value, if not given for a sample</span>
<span class="sd">        max_ncols: maximal number of columns where several axes are plotted in</span>
<span class="sd">            the same figure</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span>
        <span class="n">dict_samples</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">dict_sample_params</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">dict</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">dict_column_ranges</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">float</span><span class="p">,</span> <span class="nb">float</span><span class="p">]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">dict_default_sample_params</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">dict</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="o">**</span><span class="n">dict_default_params</span>
    <span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_params</span> <span class="o">=</span> <span class="p">{</span>
            <span class="s2">&quot;bins&quot;</span><span class="p">:</span> <span class="mi">50</span><span class="p">,</span>
            <span class="s2">&quot;density&quot;</span><span class="p">:</span> <span class="s2">&quot;candidates&quot;</span><span class="p">,</span>
            <span class="s2">&quot;factor_ymax&quot;</span><span class="p">:</span> <span class="mf">1.1</span><span class="p">,</span>
        <span class="p">}</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_sample_params</span> <span class="o">=</span> <span class="p">{</span>
            <span class="s2">&quot;bar_mode&quot;</span><span class="p">:</span> <span class="kc">True</span>
        <span class="p">}</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">max_ncols</span> <span class="o">=</span> <span class="mi">3</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">dict_samples</span> <span class="o">=</span> <span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_samples</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_sample_params</span> <span class="o">=</span> <span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_sample_params</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_column_ranges</span> <span class="o">=</span> <span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_column_ranges</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_default_params</span><span class="p">(</span><span class="o">**</span><span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_default_params</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_default_sample_params</span><span class="p">(</span>
            <span class="o">**</span><span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_default_sample_params</span><span class="p">))</span>

<div class="viewcode-block" id="Plotter.from_lists"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.from_lists">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">from_lists</span><span class="p">(</span>
        <span class="n">list_sample_names</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
        <span class="n">list_samples</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">],</span>
        <span class="n">dict_default_params</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">dict</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">dict_column_ranges</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">dict</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="o">**</span><span class="n">dict_list_default_params</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">list</span><span class="p">]</span>
    <span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Initiate a plotter instance using lists.</span>

<span class="sd">        Args:</span>
<span class="sd">            list_names: list of the names of the samples</span>
<span class="sd">            list_samples: list of the samples</span>
<span class="sd">            default_params: associates a parameter name with its default</span>
<span class="sd">                value</span>
<span class="sd">            **dict_list_default_params: associates a sample parameter name</span>
<span class="sd">                with a list of values, each value is associated with</span>
<span class="sd">                the corresponding sample</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">plotter</span> <span class="o">=</span> <span class="n">Plotter</span><span class="p">(</span>
            <span class="n">dict_column_ranges</span><span class="o">=</span><span class="n">dict_column_ranges</span><span class="p">,</span>
            <span class="o">**</span><span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_default_params</span><span class="p">)</span>
        <span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">sample</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span>
                <span class="nb">zip</span><span class="p">(</span><span class="n">list_sample_names</span><span class="p">,</span> <span class="n">list_samples</span><span class="p">)):</span>
            <span class="n">plotter</span><span class="o">.</span><span class="n">add_sample</span><span class="p">(</span>
                <span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">sample</span><span class="o">=</span><span class="n">sample</span><span class="p">,</span>
                <span class="o">**</span><span class="p">{</span>
                    <span class="n">param_name</span><span class="p">:</span> <span class="n">list_param_values</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
                    <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">list_param_values</span>
                    <span class="ow">in</span> <span class="n">dict_list_default_params</span><span class="o">.</span><span class="n">items</span><span class="p">()</span>
                <span class="p">}</span>
            <span class="p">)</span>

        <span class="k">return</span> <span class="n">plotter</span></div>

<div class="viewcode-block" id="Plotter.add_sample"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.add_sample">[docs]</a>    <span class="k">def</span> <span class="nf">add_sample</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">sample</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="o">**</span><span class="n">dict_sample_params</span>
    <span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Add a sample.</span>

<span class="sd">        Args:</span>
<span class="sd">            name: name of the sample</span>
<span class="sd">            sample: the sample</span>
<span class="sd">            dict_sample_params: associates a sample parameter name with</span>
<span class="sd">                its value (for the given sample)</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_samples</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">sample</span>
        <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param_value</span> <span class="ow">in</span> <span class="n">dict_sample_params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">param_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">dict_sample_params</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">dict_sample_params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">dict_sample_params</span><span class="p">[</span><span class="n">param_name</span><span class="p">][</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">param_value</span></div>

<div class="viewcode-block" id="Plotter.add_default_params"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.add_default_params">[docs]</a>    <span class="k">def</span> <span class="nf">add_default_params</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">dict_default_params</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add default parameters&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_params</span> <span class="o">=</span> <span class="p">{</span>
            <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">dict_default_params</span><span class="p">,</span> <span class="o">**</span><span class="n">dict_default_params</span>
        <span class="p">}</span></div>

<div class="viewcode-block" id="Plotter.add_default_sample_params"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.add_default_sample_params">[docs]</a>    <span class="k">def</span> <span class="nf">add_default_sample_params</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">dict_default_sample_params</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add default sample parameters&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_sample_params</span> <span class="o">=</span> <span class="p">{</span>
            <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">dict_default_sample_params</span><span class="p">,</span>
            <span class="o">**</span><span class="n">dict_default_sample_params</span><span class="p">}</span></div>

<div class="viewcode-block" id="Plotter.get_param"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.get_param">[docs]</a>    <span class="k">def</span> <span class="nf">get_param</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">param_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">kwargs</span><span class="p">:</span> <span class="nb">dict</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Get the value of a parameter according to a dictionnary, or</span>
<span class="sd">        the default value of the instance of it is not in this dictionnary.</span>

<span class="sd">        Args:</span>
<span class="sd">            param_name: name of the parameter</span>
<span class="sd">            kwargs: dictionnary associating parameter names with values</span>

<span class="sd">        Returns:</span>
<span class="sd">            param_value: the value of the parameter according to kwargs,</span>
<span class="sd">                or according to `Plotter.dict_default_params`</span>
<span class="sd">                or `None` if nothing was found.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param_name</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param_name</span><span class="p">))</span></div>

<div class="viewcode-block" id="Plotter.plot_hist_one_column"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.plot_hist_one_column">[docs]</a>    <span class="k">def</span> <span class="nf">plot_hist_one_column</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span> <span class="n">list_sample_names</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
        <span class="n">column</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Plot the histogram of a column in different samples.</span>

<span class="sd">        Args:</span>
<span class="sd">            list_sample_names: list of the sample names to plot</span>
<span class="sd">            column: name of the column to plot</span>
<span class="sd">            **kwargs: passed to :py:func:`lib.plot.plot_hist.plot_hist`</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Only get the low and high values if the bin centres or edges are</span>
        <span class="c1"># not given</span>
        <span class="n">bins</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;bins&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">bins</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">bins</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
            <span class="n">column_range</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">dict_column_ranges</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">column</span><span class="p">,</span> <span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">))</span>
            <span class="n">low</span><span class="p">,</span> <span class="n">high</span> <span class="o">=</span> <span class="n">column_range</span>

        <span class="c1"># Parameters related to the samples</span>
        <span class="n">dict_sample_params_plot</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">dict_param_values</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">dict_sample_params</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">dict_sample_params_plot</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">sample_name</span> <span class="ow">in</span> <span class="n">list_sample_names</span><span class="p">:</span>
                <span class="n">dict_sample_params_plot</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
                    <span class="n">dict_param_values</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                        <span class="n">sample_name</span><span class="p">,</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">dict_default_sample_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param_name</span><span class="p">)</span>
                    <span class="p">)</span>
                <span class="p">)</span>

        <span class="k">return</span> <span class="n">plot_hist</span><span class="p">(</span>
            <span class="n">samples</span><span class="o">=</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">dict_samples</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">list_sample_names</span><span class="p">],</span>
            <span class="n">column</span><span class="o">=</span><span class="n">column</span><span class="p">,</span>
            <span class="n">low</span><span class="o">=</span><span class="n">low</span><span class="p">,</span> <span class="n">high</span><span class="o">=</span><span class="n">high</span><span class="p">,</span>
            <span class="o">**</span><span class="n">dict_sample_params_plot</span><span class="p">,</span>
            <span class="c1"># overwrite the default parameters</span>
            <span class="o">**</span><span class="p">{</span><span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">dict_default_params</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">},</span>
            <span class="o">**</span><span class="n">kwargs</span>
        <span class="p">)</span></div>

<div class="viewcode-block" id="Plotter.plot_hist"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.plotter.Plotter.plot_hist">[docs]</a>    <span class="k">def</span> <span class="nf">plot_hist</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">list_sample_names</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
                  <span class="n">list_columns</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]],</span>
                  <span class="n">one_fig</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
                  <span class="n">one_leg</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
                  <span class="n">title</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
                  <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Plot one-dimensional histograms in several samples and columns.</span>

<span class="sd">        Args:</span>
<span class="sd">            list_sample_names: names of the samples that are plotted</span>
<span class="sd">            list_columns: list of the columns which the histograms are</span>
<span class="sd">                plotted in</span>
<span class="sd">            one_fig: whether to have only one big figure for all the columns,</span>
<span class="sd">                to plot the columns in separate figures</span>
<span class="sd">            one_leg: whether to show only one time the legend, or to show</span>
<span class="sd">                it in all the plots</span>
<span class="sd">            title: title of the figure(s)</span>
<span class="sd">            **kwargs: passed to :py:func:`lib.plot.plot_hist.plot_hist`</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">list_columns</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span> <span class="ow">or</span> <span class="ow">not</span> <span class="n">one_fig</span><span class="p">:</span>
            <span class="n">list_columns</span> <span class="o">=</span> <span class="n">_type_to_list</span><span class="p">(</span><span class="n">list_columns</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span>

            <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_columns</span><span class="p">:</span>
                <span class="n">fig</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">plot_hist_one_column</span><span class="p">(</span>
                    <span class="n">list_sample_names</span><span class="p">,</span> <span class="n">column</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span>
                <span class="p">)</span>
                <span class="k">if</span> <span class="n">title</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">fig</span><span class="o">.</span><span class="n">suptitle</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>

        <span class="k">else</span><span class="p">:</span>
            <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span> <span class="o">=</span> <span class="n">get_multi_fig_ax</span><span class="p">(</span>
                <span class="nb">len</span><span class="p">(</span><span class="n">list_columns</span><span class="p">),</span> <span class="bp">self</span><span class="o">.</span><span class="n">max_ncols</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">column</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">list_columns</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">one_leg</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">i</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                        <span class="n">default_factor_ymax</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_param</span><span class="p">(</span>
                            <span class="s2">&quot;factor_ymax&quot;</span><span class="p">,</span> <span class="n">kwargs</span>
                        <span class="p">)</span>
                    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_columns</span><span class="p">)</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">max_ncols</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                        <span class="n">show_leg</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span> <span class="o">==</span> <span class="mi">0</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">show_leg</span><span class="p">:</span>
                            <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;factor_ymax&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="mf">1.6</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;factor_ymax&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">default_factor_ymax</span>

                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">show_leg</span> <span class="o">=</span> <span class="kc">False</span>
                        <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;factor_ymax&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="mf">1.1</span>

                    <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;show_leg&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">show_leg</span>

                <span class="bp">self</span><span class="o">.</span><span class="n">plot_hist_one_column</span><span class="p">(</span>
                    <span class="n">list_sample_names</span><span class="p">,</span> <span class="n">column</span><span class="p">,</span>
                    <span class="n">ax</span><span class="o">=</span><span class="n">axes</span><span class="p">[</span><span class="n">i</span><span class="p">],</span>
                    <span class="o">**</span><span class="n">kwargs</span>
                <span class="p">)</span>
            <span class="k">if</span> <span class="n">one_leg</span> <span class="ow">and</span> <span class="ow">not</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_columns</span><span class="p">)</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">max_ncols</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">tight_layout</span><span class="p">()</span>
                <span class="n">axes</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="p">(</span><span class="mf">1.05</span><span class="p">,</span> <span class="mf">0.1</span><span class="p">))</span>

            <span class="k">if</span> <span class="n">title</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">fig</span><span class="o">.</span><span class="n">suptitle</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">top</span><span class="o">=</span><span class="mf">0.92</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>